<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/strict.dtd">
<html>
<head>

<!-- 
	University of Illinois/NCSA Open Source License for expusersrun.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.champwilde.f9.co.uk/idmphp/expusers
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 
 
pkiexp.php is intended to lookup and present the expiry dates of the ssl certificates
in an edirectory implementation, and highlight those which will expire soon.

 -->

<title>Expired Users Notification</title>

</head>
<body>

<h1>NDS Expired Users List</h1>

<?php
// newer systems support the _post system for posted variable
// older ones http_post_vars so we test for both...
// Thanks to Mike James for spotting this problem - I don't have a system which
// doesn't support http_post_vars so hadn't seen it. Thanks also to
// Sebastian Lukasz who tested out this fix.

// this is a quick string for a style for the table to give a basic border round the cells
// however really you should leave this blank and use a style sheet...
$tstyle = " style=\"spacing:1em; border-style:solid; border-width:1px;\"";

if (@$_POST['ldap_id'] > "" ) {
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$admin_email=$_POST['admin_email'];
	$ldap_server=$_POST['ldap_server'];
	$ldap_root= $_POST['ldap_root'];
	$aheadalert= $_POST['aheadalert'];
	$behindalert= $_POST['behindalert'];
	$unusedacalert= $_POST['unusedacalert'];
	$adminaheadalert = $_POST['adminalert'];
	if ($_POST['createemail'] == "TRUE") {
		$create_email_output = TRUE;
	} else {
		$create_email_output = FALSE;
	}
	if ($_POST['createhtml'] == "TRUE") {
		$create_html_file_output = TRUE;
	} else {
		$create_html_file_output = FALSE;
	}
	
} else {
	if (@$HTTP_POST_VARS['ldap_id'] > "" ) {
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$admin_email=$HTTP_POST_VARS['admin_email'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		$ldap_root= $HTTP_POST_VARS['ldap_root'];
		$months_ahead= $HTTP_POST_VARS['months_ahead'];
		$aheadalert= $HTTP_POST_VARS['aheadalert'];
		$behindalert = $HTTP_POST_VARS['behindalert'];
		$unusedacalert = $HTTP_POST_VARS['unusedacalert'];
		$adminaheadalert = $HTTP_POST_VARS['adminalert'];
		if ($HTTP_POST_VARS['createemail'] == "TRUE") {
			$create_email_output = TRUE;
		} else {
			$create_email_output = FALSE;
		}
		if ( $HTTP_POST_VARS['createhtml'] == "TRUE") {
			$create_html_file_output = TRUE;
		} else {
			$create_html_file_output = FALSE;
		}
	} else {
		DisplayForm();
		exit;
	}
}

$supportDeskTitle= "Service Desk";
$smtpServer = "mail.yourdomain.com";

// Various EMail Addresses
// source email address
$mail_From = $admin_email;
// Mail is sent to default if there is no email address found for the owner in LDAP - this could
// be users who no longer exist or systems ids with no email address set.
$defaultOwnerEmail = $admin_email;
// This is a friendly name for messages sent to above
$defaultOwnerFriendlyName = $supportDeskTitle;

// these placeholders are used in formatting the mail message...
// we use search replace on them later - kinda mail merge
$friendlyNamePlaceHolder = "[[insert friendly name here!]]";
$userNamePlaceHolder = "[[insert user name here]]";
$expiryDatePlaceHolder = "[[insert expiry date here]]";

$mail_Body_User = "Dear " . $friendlyNamePlaceHolder . ",\n\n";
$mail_Body_User .="Your network account " . $userNamePlaceHolder . " is due to expire on " . $expiryDatePlaceHolder;
$mail_Body_User .= ". If your contract has been extended please forward this email to your line manager asking them";
$mail_Body_User .= " to return the email to the $supportDeskTitle requesting an extension";
$mail_Body_User .= " and stating the new expiry date, otherwise your account will be disabled";
$mail_Body_User .= " on the date shown.\n\n";

$mail_Body_Admin = "Dear " . $friendlyNamePlaceHolder . ",\n\n";
$mail_Body_Admin .="Network account " . $userNamePlaceHolder . " is due to expire on " . $expiryDatePlaceHolder  ;
$mail_Body_Admin .= ". There is no email address recorded so please correct this so that";
$mail_Body_Admin .= " the user will get a reminder next week or contact";
$mail_Body_Admin .= " the manager to see if an extension is required.\n\n";

$mail_Footer = "\nIf you have any questions or require any help with this please contact the $supportDeskTitle.\n\n";
$mail_Footer .= "Thank you.\n\n$supportDeskTitle.\n";

// ********************* End of Setup section *************************************

//Display text on console...
echo "<p>Running dsexpulist PHP Script : ";
$today = getdate();
echo $today['hours'] . ":" . str_pad($today['minutes'], 2, "0", STR_PAD_LEFT) . ", " . $today['mday'] . "/" . $today['mon'] . "/" . $today['year'];
echo "</p>\n";

// All time calcs are in Unix system time so convert days to seconds
// in the values set up above
$aheadalert= $aheadalert * 24 * 60 * 60; // 42 days in secs
$adminaheadalert= $adminaheadalert * 24 * 60 * 60; // 42 days in secs
$behindalert = $behindalert  * 24 * 60 * 60; // 30 days/ this is the account use trigger - if account not last logged in in last 30 days
$unusedacalert =$unusedacalert * 24 * 60 * 60; // 30 days

$daynow = mktime(0,0,0, $today['mon'] ,$today['mday'] ,  $today['year']);
$dayahead = $daynow + $aheadalert;
$daybehind = $daynow - $behindalert;
$dayacunused = $daynow - $unusedacalert;
$dayadmin = $dayahead - ($aheadalert - $adminaheadalert);

//echo "Day rightnow \t" . date("d m y",$daynow) . "\n";
//echo "Day ahead \t" . date("d m y",$dayahead) . "\n";
//echo "Day behind \t" . date("d m y",$daybehind) . "\n";
//echo "Dayacunused \t" . date("d m y",$dayacunused) . "\n";
//echo "Day admin \t" . date("d m y",$dayadmin) . "\n";

//Set up the HTML page if required. Bomb out if its not. We don't carry on
// even if its email only because the script is designed to be run on
// a clustered setup

if ($create_html_file_output) {

	// kick off the output file
	$body =  "<p>List created ";
	$body .= str_pad($today['hours'], 2, "0", STR_PAD_LEFT);
	$body .= ":" . str_pad($today['minutes'], 2, "0", STR_PAD_LEFT);
	$body .= ", " . $today['mday'] . "/" . str_pad($today['mon'], 2, "0", STR_PAD_LEFT);
	$body .= "/" . $today['year'] . "</p>\n";
	// bang out headers
	$body .= "<table cellpadding=\"0\" cellspacing=\"0\" summary =\"NDS Expired Users List \">\n";
	$body .= "<tr class = \"ndsinfo\" >\n";	
	$body .= "   <th $tstyle  scope=\"col\" class = \"ndsinfo\" >Username</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >DN (inc context)</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Account Expiry</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Last Login</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Description</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Given Name</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Surname</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Internet Email</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Notes Email</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Telephone</th>\n";	
	$body .= "   <th $tstyle  scope=\"col\"  >Home Directory</th>\n";	
	$body .= "</tr>\n";	
}
if($create_email_output) {
	// format the mailfrom Address...
	$mail_From  =  "From: " .  $mail_From . "\r\n" . "Reply-To: " . $mail_From . "\r\n" . "X-Mailer: PHP/" . phpversion();
	ini_set("SMTP",$smtpServer ); 
}


// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection
// So we start by connecting to LDAP
echo "<p>Connecting to LDAP server...\n";
$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!
if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo "Connection succeeded.<br>\n";
	// we have now made an LDAP connection
} else { 
	echo " LDAP Authentication Failed<br>\n";
	echo "User id and/or Password credentials were incorrect.</p>\n";
	// and we exit if the ldap server is unavailable.
	exit;
}

echo "Running the LDAP Search...\n";
// do the search
$ldap_sr = "loginExpirationTime=*" ;
$sr=@ldap_search($ds, $ldap_root, $ldap_sr ,array(cn, givenName, sn, mail, eMailAddress, ndsHomeDirectory, telephoneNumber, loginTime, loginDisabled, loginExpirationTime, description )); 
//echo  $ds .  $ldap_root .  $ldap_sr . "\n";  
$entry = @ldap_first_entry($ds, $sr);
$entrycount = @ldap_count_entries($ds, $sr); 
echo $entrycount . " directory entries returned.<br>\n";

while ($entry) {
	// run through each entry
	$attrs = @ldap_get_attributes($ds,$entry);
	// get the acount expiration time and last login and store them 
	// in unix format	
	$acexpdate = @ndsstrtotime(@$attrs["loginExpirationTime"][0]);
	$aclastlogin = @ndsstrtotime(@$attrs["loginTime"][0]);
	//get cn and dn
	$user_cn =  @$attrs["cn"][0] ;
	$user_dn = @ldap_get_dn($ds,$entry);
	$user_dn =  str_ireplace("cn="," ",$user_dn) ;
	$user_dn =  str_ireplace(",ou=",".",$user_dn) ;
	$user_dn =  trim(str_ireplace(",o=",".",$user_dn)) ;
	
	if (strlen(@$attrs["loginExpirationTime"][0]) > 7) {
		//and it ought to be, because the LDAP search was on exp time!
		// then format expiry time in dd/m/yy for display/emails 
		$user_exptime =  substr(@$attrs["loginExpirationTime"][0],6,2) ."/";
		$user_exptime .= substr(@$attrs["loginExpirationTime"][0],4,2) . "/";
		$user_exptime .= substr(@$attrs["loginExpirationTime"][0],0,4);
	} else {
		$user_exptime = "No valid expiration time found.";
		echo "Error on user " . $user_dn . " - no loginExpiration Time. This should not be reachable.<br>\n";
	}

	//set some flags for use later... strictly speaking
	// these are pretty much unnecessary, but they improve readability and
	// these options can get might confusing while you're debugging... 
	if ($aclastlogin < $dayacunused ) {
		$AccountUnused = TRUE;
	} else {
		$AccountUnused = FALSE;
	}
	
	if(@$attrs["loginDisabled"][0] == "TRUE") {
		$AccountDisabled = TRUE;
	} else {
		$AccountDisabled = FALSE;
	}

	if ($acexpdate <= $dayahead and $acexpdate >= $daybehind){
		$inActionTimeWindow = TRUE;
	} else {
		$inActionTimeWindow = FALSE;
	}	
		
	if ($acexpdate <= $dayahead and $acexpdate >= $dayadmin){
		$inAdminTimeWindow = TRUE;
	} else {
		$inAdminTimeWindow = FALSE;
	}		
	
	if ($acexpdate <= $dayahead and $acexpdate > $daynow){
		$inEmailTimeWindow = TRUE;
	} else {
		$inEmailTimeWindow = FALSE;
	}		

	// discard all accounts not in the action time window
	// and discard all disabled accounts
	if ($inActionTimeWindow and !$AccountDisabled) {
		// format homedir for use later
		if (strlen(@$attrs["ndsHomeDirectory"][0]) > 1) {
			$hdir =  str_ireplace("cn=","",@$attrs["ndsHomeDirectory"][0]) ;
			$hdir = substr($hdir,0,strpos($hdir,","));
			$hdir =  trim( str_ireplace("_","\\",$hdir) );
			$hdir = $hdir .  trim(substr(@$attrs["ndsHomeDirectory"][0], strrpos(@$attrs["ndsHomeDirectory"][0], "#")));
			$hdir =  str_ireplace("/","\\",$hdir) ;
			$hdir =  str_ireplace("#","\\",$hdir) ;
			$hdir =  str_ireplace("\\\\","\\",$hdir) ;
			$hdir = "\\\\" . $hdir;
			
			$hcxt = trim(substr(@$attrs["ndsHomeDirectory"][0], 0, strpos(@$attrs["ndsHomeDirectory"][0], "#0#")));
			$hcxt = str_ireplace("cn=",".",$hcxt) ;
			$hcxt = str_ireplace(",ou=",".",$hcxt) ;
			$hcxt =  str_ireplace(",o=",".",$hcxt) ;
		} else {
			$hdir="";
			$hcxt="";
		}

		$userTel = @$attrs["telephoneNumber"][0];
		$ownerEmail =  @$attrs["mail"][0] ;
		
		if ($create_html_file_output){
			// start on the html presentation
			$body .= "<tr  >\n";
			$body .= "   <td $tstyle >" . $user_cn . "</td>\n";
			$body .= "   <td $tstyle >" . $user_dn . "</td>\n";
			$body .= "   <td $tstyle >" . $user_exptime . "</td>\n";
			
			if (strlen(@$attrs["loginTime"][0]) > 1) {
				$body .= "   <td $tstyle >" . substr(@$attrs["loginTime"][0],6,2) . "/" ;
				$body .= substr(@$attrs["loginTime"][0],4,2) . "/" ;
				$body .= substr(@$attrs["loginTime"][0],0,4) . "</td>\n";
			} else {
				$body .= "   <td $tstyle >Never</td>\n";
			}
			
			$body .= "   <td $tstyle >" . @$attrs["description"][0] . "&nbsp;</td>\n";
			$body .= "   <td $tstyle >" . @$attrs["givenName"][0] . "&nbsp;</td>\n";
			$body .= "   <td $tstyle >" . @$attrs["sn"][0] . "</td>\n";
			$body .= "   <td $tstyle >" . $ownerEmail . "&nbsp;</td>\n";
			$body .= "   <td $tstyle >" . ltrim(@$attrs["eMailAddress"][0],"0#") . "&nbsp;</td>\n";
			$body .= "   <td $tstyle >" . $userTel . "&nbsp;</td>\n";
		
			if (strlen($hdir) > 1) {
				$body .= "   <td $tstyle >" .$hcxt . "\n" . $hdir . "&nbsp;</td>\n";
			} else {
				$body .= "   <td $tstyle >&nbsp;</td>\n";
			}
			$body .= "</tr>\n";
		}

		if ($create_email_output) {
		// now we work on emails...			
			$ownerFriendlyName =  @$attrs["givenName"][0] . " " . @$attrs["sn"][0] ;

			if (strlen($ownerEmail)> 3)  {
				// we check length of email address - it shoud have returned from LDAP or it could be blank
				$email_present = TRUE;
			} else {
				$email_present = FALSE;
			}
			
			if ($email_present)  {
				// and replace the placeholders with the email details in the mail header
				$mail_Title = "Warning: Your LAN Account Expires Soon.";
				$mail_Message = str_replace($friendlyNamePlaceHolder,$ownerFriendlyName,$mail_Body_User);
				$mail_Message = str_replace($userNamePlaceHolder, $user_dn,$mail_Message);
				$mail_Message = str_replace($expiryDatePlaceHolder, $user_exptime ,$mail_Message);
			} else {
				// if its short we assume we use the default value - a@cc is probably the shortest legal email address!
				// so this email is going to the admins
				// but only if its in the admin window...
				if ($inAdminTimeWindow) {  
					$ownerEmail =  $defaultOwnerEmail;

					if (strlen($ownerEmail)> 3)  {
						$email_present = TRUE;
					} else {
						$email_present = FALSE;
					}
										
					// so here we do the replacement slightly differently using the defaults
					$mail_Message = str_replace($friendlyNamePlaceHolder,$defaultOwnerFriendlyName,$mail_Body_Admin);
					$mail_Message = str_replace($userNamePlaceHolder, $user_dn,$mail_Message);
					$mail_Message = str_replace($expiryDatePlaceHolder, $user_exptime ,$mail_Message);
					
					// we get loads of extra detail herefor the admin paragraph...
					$mail_Title = "Account Expiry: " . $user_dn;
					
					if (strlen(@$attrs["loginTime"][0]) > 7) {
						$user_lastlogin = substr(@$attrs["loginTime"][0],6,2) . "/" ;
						$user_lastlogin .= substr(@$attrs["loginTime"][0],4,2) . "/" ;
						$user_lastlogin .= substr(@$attrs["loginTime"][0],0,4) ;
					}
	
					$mail_Message .= "The user details are as follows:-\n";
					$mail_Message .= "CN:        \t" . $user_cn . "\n";
					$mail_Message .= "DN:        \t" . $user_dn . "\n";
					$mail_Message .= "Name:      \t" . $ownerFriendlyName . "\n";
					$mail_Message .= "Expiry:    \t" . $user_exptime . "\n";
					$mail_Message .= "Last Login:\t" . $user_lastlogin . "\n";
					$mail_Message .= "Tel:       \t" . $userTel . "\n";
					$mail_Message .= "Homedir:   \t" . $hdir . " " . $hcxt . "\n";
				}				
			}
			
			//echo "About to email\n";
			if($inEmailTimeWindow AND $email_present) {
				// We only bother to email off messages if the expiry date isn't past...
				//we check on email flag because it could be false if the user
				//isn't in the admin time window, and in that case we don't
				//want to send a message
				echo "Sending email to ";
				echo $ownerEmail . " about " . $user_cn .".<br>\n";
				mail ($ownerEmail,$mail_Title,$mail_Message,$mail_From);
			}								
		}
	}
	//echo "next entry\n";
	$entry = @ldap_next_entry($ds, $entry);
}

if ($create_html_file_output){
	$body .="</table>\n";
	//echo  "\nCreating the output file...\n";
	echo "</p>\n $body";
}

ldap_close($ds);

echo "<p>dsexpulist PHP Script completed.</p>\n\n";
exit();

function ndsstrtotime($instr) {
// converts in string in LDAP/Netware date/time format
// eg 20090106115900Z
// which is yyyymmddhhmm???
// to a Unix system time in secs, base 1970
	$siyear=substr($instr,0,4);
	$simonth=substr($instr,4,2);
	$siday =substr($instr,6,2);
	return	mktime(0,0,0,$simonth,$siday,$siyear);
}

function DisplayForm() {
// this produces the form to fill in when there's not a ldap _id in the post vars. 
$form_body = <<<HTMLFORM
<form method="POST" action="expulist.php"
	enctype="x-www-form-urlencoded">
<table class="main" cellpadding="2" cellspacing="2">
	<tr>
		<td $tstyle >LDAP Admin User ID:</td>
		<td $tstyle ><input type="text" name="ldap_id" size="30"
			maxlength="80"></td>
	</tr>
	<tr>
		<td $tstyle >LDAP Password:</td>
		<td $tstyle ><input type="password" name="ldap_pw"
			size="30" maxlength="40"></td>
	</tr>
		<tr>
		<td $tstyle >Admin's Email Address:</td>
		<td $tstyle ><input type="text" name="admin_email"
			size="30" maxlength="80"></td>
	</tr>
	<tr>
		<td $tstyle >LDAP Server:</td>
		<td $tstyle ><input type="text" name="ldap_server"
			size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>
	<tr>
		<td $tstyle >Working OU/Context:</td>
		<td $tstyle ><input type="text" name="ldap_root"
			size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td $tstyle >List accounts due to expire during next:</td>
		<td $tstyle ><input type="text" name="aheadalert"
			value="28" size="3" maxlength="10"> Day(s).</td>
	</tr>
	<tr>
		<td $tstyle >List Accounts expired during previous:</td>
		<td $tstyle ><input type="text" name="behindalert"
			value="28" size="3" maxlength="10"> Day(s).</td>
	</tr>
	<tr>
		<td $tstyle >Do not list accounts unused for more than:</td>
		<td $tstyle ><input type="text" name="unusedacalert"
			value="7" size="3" maxlength="10"> Day(s).</td>
	</tr>
	
	<tr>
		<td $tstyle >Administrator Alert Window</td>
		<td $tstyle ><input type="text" name="adminalert"
			value="7" size="3" maxlength="10">Days.</td>
	</tr>
		<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>
	
	<tr>
		<td $tstyle >
			Send individual emails to the users<br>
			Don't send emails
		</td>
		<td $tstyle >
			<input type="radio" name="createemail" value="TRUE" checked="checked" /><br>
			<input type="radio" name="createemail" value="FALSE" />
		</td>
	</tr>
	<tr>
		<td colspan="2">
			<hr>
		</td>
	</tr>
		
	<tr>
		<td $tstyle >
			Display table of details accounts due to expire<br>
			No Table of users
		</td>
		
		<td $tstyle >
			<input type="radio" name="createhtml" value="TRUE" checked="checked" /><br>
			<input type="radio" name="createhtml" value="FALSE" />
		</td>
	</tr>
	

	<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>
		
	<tr>
		<td $tstyle ><input type="submit" value="Post Details"></td>
		<td $tstyle ><input type="reset" value="Clear Form"></td>
	</tr>
</table>
</form>
<h3>Notes and Help</h3>
<p>The time options let you control which users will be reported. If
you are going to run the script monthly then a list of all user accounts
which will expire in the next 30 days and which have been used in the
last 10 days will enable you to identify accounts that are currently
active, and so it could be worth contacting the manager to see whether
the expiry date is still valid and find out what should be done with any
user data.<br>
Alternatively a list of accounts that have expired in the last month
will be useful to list housekeeping required, accounts and home
directories to be deleted etc.</p>
<p>LDAP Admin user id must be in typeful LDAP format ie <code>cn=adminuser,o=organisation</code>.
The delimiters must be commas and not full stops.</p>
<p>LDAP server. It would be best to pick a server that holds
replicas containing the objects that you wish to edit.</p>
<p>Working OU/Context must also be in typeful LDAP format, so <code>ou=dept,ou=building,ou=town,o=organisation</code>.
Unless you have a very large tree indeed this probably should be the
base organisation in the Directory.</p>
<p>Most of the time options should be self explanatory.  The Administrator 
Alert Window is used with emails when the user
doesn't have an email address in the directory. Emails notifications
only go to the administrator during the next n days after the expiry
date. The reason for this is that the program was designed to run weekly, with
users getting alerts from 28 days before the account expires. That would mean
the helpdesk getting four messages for each unused account. The idea of the alert window
is that the administrators only get one such message.</p> 

HTMLFORM;
echo $form_body;
}

?>
</body>
</html>

